leetcode : 64 最小路径和 动态规划

64. 最小路径和

题目链接https://leetcode.cn/problems/minimum-path-sum/

题目描述

给定一个包含非负整数的 m x n 网格,请找出一条从左上角到右下角的路径,使得路径上的数字总和为最小。

说明:每次只能向下或者向右移动一步。

示例:

复制代码
 [1,3,1]
 [1,5,1]
 [4,2,1]      

输出: 7

解释: 因为路径 1→3→1→1→1 的总和最小。

题目解法

从题目中我们可以知道,每次只能向下或者向右移动一步。

因此,第 i 行第 j 列的最小路径和与第 i-1 行第 j 列的最小路径和第i行第j-1列的最小路径和有关。

因此,我们可以用动态规划的方法来求解。

设 dpij 表示从左上角走到第 i 行第 j 列的最小路径和。

  1. 定义一个二维数组 dp,其中 dpij 表示从左上角走到第 i 行第 j 列的最小路径和。
  2. 则dpij=min(dpi-1j,dpij-1)+gridij,其中 gridij 表示网格中第 i 行第 j 列的元素。注意当i-1或者j-1越界时,说明无法从该点走到右下角,因此需要取最大值。
  3. 初始值 dp00 = grid00,其他 dpij = 0。
  4. 最后返回 dpm-1n-1,即为最小路径和。

代码实现

python版本:

python 复制代码
class Solution:
    def minPathSum(self, grid: List[List[int]]) -> int:
        if not grid or not grid[0]:
            return 0
        
        m, n = len(grid), len(grid[0])
        dp = grid
        for i in range(1, m):
            dp[i][0] = dp[i - 1][0] + grid[i][0]
        for j in range(1, n):
            dp[0][j] = dp[0][j - 1] + grid[0][j]
        for i in range(1, m):
            for j in range(1, n):
                dp[i][j] = min(dp[i - 1][j], dp[i][j - 1]) + grid[i][j]
        
        return dp[m - 1][n - 1]

Go版本:

go 复制代码
func minPathSum(grid [][]int) int {
     m:=len(grid)
     n:=len(grid[0])

     res:=make([][]int,m)
     for i:=range res{
        res[i]=make([]int,n)
     }
     res[0][0]=grid[0][0]
     for i:=1;i<n;i++{
        res[0][i]=res[0][i-1]+grid[0][i]
     }
     for i:=1;i<m;i++{
        res[i][0]=res[i-1][0]+grid[i][0]
     }
     for i:=1;i<m;i++{
        for j:=1;j<n;j++{
            res[i][j]=min(res[i-1][j],res[i][j-1])+grid[i][j]
        }
     }
     return res[m-1][n-1]
}

C++版本:

cpp 复制代码
class Solution {
public:
    int minPathSum(vector<vector<int>>& dp) {
        int m=dp.size(),n=dp[0].size();
        auto res=vector<vector<int>> (m,vector<int>(n));
        res[0][0]=dp[0][0];
        for(int i=1;i<m;i++){
            res[i][0]=res[i-1][0]+dp[i][0];
        }
        for(int j=1;j<n;j++){
            res[0][j]=res[0][j-1]+dp[0][j];
        }
        for(int i=1;i<m;i++){
            for(int j=1;j<n;j++){
                res[i][j]=min(res[i-1][j],res[i][j-1])+dp[i][j];
            }
        }
        return res[m-1][n-1];
    }
};
相关推荐
CHEEVEN_QY26 分钟前
液冷板热阻计算与流阻优化的实战方法
人工智能·算法·机器学习
C++ 老炮儿的技术栈1 小时前
不一样的数值交换
数据结构·c++·人工智能·算法·c·csdn开发云
hahaha60162 小时前
Shades-of-Gray (SoG) 算法--白平衡算法
人工智能·嵌入式硬件·算法·计算机视觉
青山木2 小时前
Hot 100 --- 编辑距离
java·数据结构·算法·leetcode·动态规划
夊3 小时前
C语言第十一课:指针(五)
算法
小师兄吃牛肉3 小时前
C语言指针进阶全解析
java·c语言·算法
梦帮科技3 小时前
vLLM / TensorRT-LLM 极限推理:PagedAttention 细粒度物理页表管理与连续批处理(Continuous Batching)实战
数据结构·人工智能·分布式·python·深度学习·算法·vllm
JAVA面经实录9173 小时前
线上故障标准处理流程【完整版|面试背诵+生产落地】
java·面试·职场和发展
yuanxi2003 小时前
青海共和百万千瓦光伏光热项目并网发电:大客户销售如何用价值力抓住能源大单
大数据·职场和发展·能源·创业创新·学习方法
做运维的阿瑞4 小时前
多表查询基础:INNER JOIN、LEFT JOIN、RIGHT JOIN
数据库·sql·mysql·算法